/*

    2007, (C) Polyanin M.A.
    See "readme.txt" for description of the program.

*/
// *********************************************
// *********************************************
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

//some user defined classes
//probably you no need to edit the file
#include "s2s_lib.h"
using Ns::uint;
using Ns::Terr;
using Ns::Terr_zptr;
using Ns::Tarray_holder;
using Ns::Tauto_array;

//some user defined classes
//probably you no need to edit the file
namespace{
#include "s2s_lib.cpp"
}

#include <list>
#include <vector>
using std::list;
using std::vector;

//#define MY_DBG

//header file of the program
#include "o2d.h"
using Ns::Tfile;
using Ns::Tline;

//header file of the program
#include "o2d_lib.cpp"

// *********************************************
// *********************************************
int     main(int argc, char *argv[])
{
char    tmpfile[L_tmpnam];
char    is_tmpfile_created=0;

FILE    *fi=0;
FILE    *fo=0;

try{
    if(argc!=2)usage();

char    *in_fname=argv[1];
Tarray_holder<char>    out_fname;

// ******************************************************
//get o file name
{
char    *ext=0;
uint    ext_offs=0;

    if( (ext=strrchr(in_fname,'.')) )
     {
      if( !stricmp(ext,out_ext) )throw "extention of input file is equal to output";
      ext_offs=static_cast<uint>(ext-in_fname);
     }

    fi=fopen(in_fname,"rb"); if(!fi)throw in_fname;
    #ifdef MY_DBG
    fprintf(stderr,"open 'fi': %s\n",in_fname);
    #endif
    fclose(fi);

    //make dump to tmpfile
    tmpnam(tmpfile);
    #ifdef MY_DBG
    printf("tmp file name: %s",tmpfile);
    #endif

    fi=fopen(tmpfile,"wb"); if(!fi)throw "write tmpfile";
    is_tmpfile_created=1;
    fclose(fi);

const uint  in_fname_len=strlen(in_fname);
{
const uint  cmdline_size=sizeof(objdump_tpl)+in_fname_len+strlen(tmpfile)+1;
Tarray_holder<char>    cmdline( new char[cmdline_size] );

    snprintf(cmdline(0),cmdline_size,objdump_tpl,in_fname,tmpfile);
    //printf(buf);
    if(system(cmdline(0)))throw Terr(cmdline(0));
}
    fi=fopen(tmpfile,"rb"); if(!fi)throw "open tmpfile";

    #ifdef MY_DBG
    fprintf(stderr,"dump 'fi': %s\n",tmpfile);
    #endif

    //make sss file name
    out_fname= new char[in_fname_len+1+strlen(out_ext)];
    strcpy( out_fname(0), in_fname );

    ext= out_fname(0)+ (ext_offs? ext_offs: in_fname_len);
    strcpy( ext, out_ext );
    fo=fopen(out_fname(0),"wt"); if(!fo)throw Terr( out_fname(0) );

    #ifdef MY_DBG
    fprintf(stderr,"open 'fo':%s\n",out_fname(0));
    #endif
}
char    buf[MAX_LEN+1];
uint    asm_lines=0;

uint    last_src_line=0;

// ******************************************************
    //create src tree
    for(;;)
     {
      if(feof(fi))break;

      //next line
      getln(buf,MAX_LEN,fi);
      ++asm_lines;
      if(!buf[0])continue;

      ////find signs
      char *ext=0;

      //5.cpp:10
      if( isspace(buf[0]) )continue;
      if(! (ext=strrchr(buf,':')) )continue;
      *ext=0;

      {
       const char    reserved[]="file";
       if( strstr(ext+1,reserved) )continue;
      }

      //files
      // *******************
      list<Tfile>::iterator   file_it(find_file(buf));

      if( file_it == files.end() )
       {
        //try open
        FILE *ff=fopen(buf,"rb"); if(!ff)continue;

        Tfile     tmp_file(files_number,ff);
        ++files_number;

        tmp_file.file_name=new char[strlen(buf)+1];
        strcpy(tmp_file.file_name(0),buf);

        //
        files.push_back(tmp_file);
        ++files_size;

        file_it=files.end();
        --file_it;
       }

      //tmp_file.first_src_line
      //lines
      // *******************
      Tline   tmp_line(asm_lines,file_it->file_number);

      if( sscanf(ext+1,"%u",&tmp_line.src_line_number) != 1 )
       {
        *ext=':';
        fprintf(stderr,tpl_bad_format,asm_lines,"get line number",buf);
        continue;
       }

      if( !file_it->first_src_line )
       {
        file_it->first_src_line=tmp_line.src_line_number;
       }
      else
       {
        if( file_it->first_src_line > tmp_line.src_line_number )
         file_it->first_src_line=tmp_line.src_line_number;
       }

      //?is_src_not_in_order
      if( last_src_line >= tmp_line.src_line_number )tmp_line.is_src_not_in_order=1;
      else last_src_line = tmp_line.src_line_number;

      #ifdef MY_DBG2
      fprintf(stderr,"%02u: file %u: line %u: %s\n",
                       asm_lines,
                       tmp_line.src_file_number, tmp_line.src_line_number,
                       (tmp_line.is_src_not_in_order? "unsorted": "ok")
                       );
      #endif

      lines.push_back(tmp_line);
      ++lines_size;

     }

    #ifdef MY_DBG
    fprintf(stderr,"press key to second pass\n");
    getchar();
    #endif

// ******************************************************
    //next pass
    if( fseek(fi,0,SEEK_SET) )throw "fseek input file";

    //find first used line for each src file
    #ifdef MY_DBG
    fprintf(stderr,"find first used line for each src file\n");
    #endif
{
list<Tfile>::iterator      it( files.begin() );

    #ifdef MY_DBG
    fprintf(stderr,"files_size: %u\n",files_size);
    #endif

    for(uint i=files_size; i; --i, ++it)
     {
      //not used
      if(!it->first_src_line)continue;

      //fprintf(stderr,"it->first_src_line: %u\n",it->first_src_line);
      if(!it->fi)throw "zptr it->fi";

      //used
      it->line_pos.push_back(0);
      ++it->line_pos_size;

      //const uint from= (it->first_src_line >= minus_area)?
      //                      ( it->first_src_line - minus_area ):
      //                      0;
      it->first_src_line= (it->first_src_line >= minus_area)?
                            ( it->first_src_line - minus_area ):
                            0;

      //if(!from)continue;
      #ifdef MY_DBG3
      fprintf(stderr,"+ it->first_src_line: %u\n",it->first_src_line);
      #endif

      if(!it->first_src_line)continue;
      list<uint>::iterator      line_pos_it( it->line_pos.begin() );

      //for(uint line=from-1; line; --line)
      for(uint line=it->first_src_line-1; line; --line)
       {
        if(feof(it->fi))
         {
          fprintf(stderr,tpl_no_file_line,it->file_name(0),it->first_src_line);
          break;
         }
        getln(0,0,it->fi);

        *line_pos_it=ftell(it->fi);
        //it->line_pos.push_back(ftell(it->fi));
        //++it->line_pos_size;
       }

      #ifdef MY_DBG3
      fprintf(stderr,"+ line_pos_it: %u\n",*line_pos_it);
      #endif
     }
}

    #ifdef MY_DBG
    fprintf(stderr,"create output\n");
    #endif

    //create output
{
std::list<Tline>::iterator      lines_it( lines.begin() );
std::list<Tline>::iterator      lines_end( lines.end() );

    for(uint asm_line=0;;)
     {
      if(feof(fi))break;

      //next line
      getln(buf,MAX_LEN,fi);
      ++asm_line;

      fprintf(fo,"%s\n",buf);
      if(!buf[0])continue;

      //include source lines
      if( lines_it->asm_line_number == asm_line )
       {
        std::list<Tline>::iterator      lines_st(lines_it++);
        //lines_it  point to next independed from unsorted state
        //lines_tmp point to cuerrent

        list<Tfile>::iterator       file_it(find_file(lines_st->src_file_number));

        if(lines_st->is_src_not_in_order)
         {
          //src "not_in_order" start sign
          fprintf(fo,"%s\n",comment_prefix);
          fprintf(fo,tpl_not_in_order_line_sign,lines_st->src_line_number,file_it->file_name(0),buf);
          fprintf(fo,"%s\n",comment_prefix);
          //continue;
         }

//const char  comment_prefix[]="#; ";
//const char  tpl_line_sign[]="#; [ %05u ] (\"%s\")\n";
//const char  tpl_not_in_order_line_sign[]="#; <<[ %05u ] (\"%s\")\n";

        else
         {
          //src start sign
          fprintf(fo,"%s\n",comment_prefix);
          fprintf(fo,tpl_line_sign,lines_st->src_line_number,file_it->file_name(0),buf);
          fprintf(fo,"%s\n",comment_prefix);
         }

        //src lines to print
        const uint from= (lines_st->src_line_number >= minus_area)?
                            ( lines_st->src_line_number - minus_area ):
                            0;

        //file_it->first_src_line+file_it->line_pos_size
        const uint to  = lines_st->src_line_number + plus_area;

        #ifdef MY_DBG3
        fprintf(stderr,"* src %u: from %u: to %u\n",lines_st->src_line_number, from, to);
        #endif

        //file_it->find_line_pos(lines_st->src_line_number);
        for(;;)
        {
        FILE *ft=file_it->fi;

        const uint pos=file_it->find_line_pos(from);
        if( int(pos)==EOF )break;

        #ifdef MY_DBG3
        fprintf(stderr,"* src %u: pos %d\n",lines_st->src_line_number, pos);
        #endif

        fseek( ft, pos, SEEK_SET );

        for( uint line=from; line <= to; ++line )
         {
          getln(buf,MAX_LEN,ft);

          if(line==lines_st->src_line_number)
           fprintf(fo,
                    "%s===\n"
                    "%s %d; %s\n"
                    "%s===\n",
                    comment_prefix,
                    comment_prefix,
                    (line-lines_st->src_line_number),
                    buf,
                    comment_prefix
                  );
          else
           fprintf(fo,
                    "%s%+d; %s\n",
                    comment_prefix,
                    (line-lines_st->src_line_number),
                    buf
                  );

          if(feof(ft))break;
         }

         break;
         }

       fprintf(fo,"%s\n",comment_prefix);
       //endif include source lines
       }

     //endfor create output
     }

//end create output
}

}
// ******************
catch(const char* err)
{
    fprintf(stderr,"error: %s\n",err);
}
// ******************
catch(...)
{
    fprintf(stderr,"error: %s\n","unknown");
}

// ******************
try{ if(is_tmpfile_created)if(remove(tmpfile))throw 0; }
catch(...)
{
    fprintf(stderr,"error removing: %s\n",tmpfile);
}
// ******************
    //if(fi){ fclose(fi); }
    //if(fo){ fclose(fo); }

// ******************
// ******************
}

