/*
   some user defined classes of the program
   probably you no need to edit the file
*/

#ifndef S2S_LIB_H
#define S2S_LIB_H

namespace Ns
{
// *********************
typedef unsigned int        uint;

// *********************
// *********************
class Terr
{
protected:
    const char    *msg_shared;
    const char    *msg_copied;

    void  do_copy(const char *const who)
     {
      if(who)try
       {
        const uint len=strlen(who);
        if(!len)return;

        char *const tmp=new char[len+1];
        strcpy(tmp,who);
        msg_copied=tmp;
       }
      catch(...){ msg_shared="no memory"; }
     }

public:
    const char*     what(){ return msg_copied? msg_copied: msg_shared; }

public:
    ~Terr(){ delete msg_copied; }

    Terr(const char *const who, const int):
        msg_shared(who),
        msg_copied(0)
     {}

    Terr(const char *const who):
        msg_shared("unknown"),
        msg_copied(0)
     {
      do_copy(who);
     }

public:
    Terr(const Terr& obj):
        msg_shared(obj.msg_shared),
        msg_copied(0)
     {
      do_copy(obj.msg_copied);
     }

    Terr& operator= (const Terr& obj)
     {
      if( &obj != this )
       {
        msg_shared=obj.msg_shared;
        delete msg_copied; msg_copied=0;
        do_copy(obj.msg_copied);
       }
      return *this;
     }

};

class Terr_zptr: public Terr
{
    Terr_zptr(const char *const who, const int):
        Terr(who,0)
     {}

    Terr_zptr(const char *const who):
        Terr(who)
     {}
};

// *********************
// *********************
template<class Tobj>
class Theap_array
{
public:
    //from new Tobj[]
    Tobj    *ptr;

    void    destroy(){ delete[] ptr; ptr=0; }
    void    replace(Tobj *const obj){ if(ptr!=obj){if(ptr)delete[] ptr; ptr=obj;} }
    Tobj*   move(){ Tobj *const tmp=ptr; ptr=0; return tmp; }
    void    detach(){ ptr=0; }

    Theap_array(Tobj *const p=0):ptr(p){}

private:
    Theap_array(const Theap_array&);
    void operator= (const Theap_array&);
};

// *********************
// *********************
namespace Nholder
{

template <class Tobj, class Tc_heap>
class Tholder
{
protected:
	mutable Tc_heap	    memory;

public:
    typedef Tc_heap     _Tc_heap;
    typedef Tobj        _Tobj;

	//do not delete
	Tobj*	get_ptr()const { return memory.ptr; }
	Tobj*	operator() (const int)const { return get_ptr(); }

	//delete required
	Tobj*	move()const { return memory.move(); }
    void    detach()const { memory.detach(); }

public:
    //from new Tobj/new Tobj[]
	Tholder(Tobj *const obj=0):memory(obj){}

    //copy by derived
private:
	Tholder(const Tholder&);
	void operator= (const Tholder&);
};

template <class Tobj, class Tc_heap=Theap_array<Tobj> >
class Tarray_holder_intf: public Nholder::Tholder<Tobj,Tc_heap>
{
    typedef  Nholder::Tholder<Tobj,Tc_heap> Tparent;
    using Tparent::memory;

public:
	//test for NULL
	//do not delete
	Tobj*	get_array()const { if(!memory.ptr)throw Terr_zptr("Tarray_holder_intf::get_array"); return memory.ptr; }
	Tobj*	operator() ()const {return get_array();}
	Tobj*	operator*  ()const {return get_array();}
	//Tobj*	operator-> ()const {return get_array();}

	//do not delete
	Tobj*	get_array_ptr()const { return memory.ptr; }
	Tobj*	operator() (const int)const { return get_array_ptr(); }

	//from new Tobj[]
	Tarray_holder_intf&	   set_array(Tobj *const obj){ memory.replace(obj); return *this; }
	//Tarray_holder_intf&  operator=  (Tobj *const obj){return set_array(obj);}

public:
	Tarray_holder_intf(Tobj *const obj=0):Tparent(obj){}

private:
	Tarray_holder_intf(const Tarray_holder_intf&);
	void operator= (const Tarray_holder_intf&);
};

//namespace Nholder
}

// *********************
// *********************
template <class Tobj, class Tc_heap=Theap_array<Tobj> >
class Tauto_array: public Nholder::Tarray_holder_intf<Tobj, Tc_heap>
{
    typedef Nholder::Tarray_holder_intf<Tobj, Tc_heap> Tparent;
    using Tparent::memory;
    //using Tparent::set_array;

public:
	//from new Tobj[]
    Tauto_array&  set_array (Tobj *const obj){ Tparent::set_array(obj); return *this; }
	Tauto_array&  operator= (Tobj *const obj){ return set_array(obj); }

	Tauto_array(Tobj *const obj=0):Tparent(obj){}
	~Tauto_array(){ memory.destroy(); }

    //
	Tauto_array(const Tauto_array& obj):Tparent( obj.move() ){}

	Tauto_array& operator= (const Tauto_array& obj)
     {
      if( this != &obj )memory.ptr=obj.move();
      return *this;
     }
};

// ***********************
template <class Tobj, class Tc_heap=Theap_array<Tobj> >
class Tarray_holder: public Nholder::Tarray_holder_intf<Tobj,Tc_heap>
{
    typedef Nholder::Tarray_holder_intf<Tobj,Tc_heap> Tparent;
    using Tparent::memory;
    //using Tparent::set_array;

public:
	//from new Tobj[]
    Tarray_holder&  set_array (Tobj *const obj){ Tparent::set_array(obj); return *this; }
	Tarray_holder&	operator= (Tobj *const obj){ return set_array(obj); }

	Tarray_holder(Tobj *const obj=0):Tparent(obj){}
	~Tarray_holder(){ memory.destroy(); }

private:
	Tarray_holder(const Tarray_holder&);
	void operator= (const Tarray_holder&);
};

//namespace Ns
}

#endif

